#include <stdio.h>
#include <stdlib.h>
#include <wiringPi.h>
#define c_wait 1

// LED表示パターンの定義
const int LED_Font[10]={ 0x3f, 0x06, 0x5b, 0x4f, 0x66,
                    0x6d, 0x7c, 0x07, 0x7f, 0x67 };

// 74HC595にn桁分送信
// LED_out(int digits. int data[])
// digitsは桁数
// data[0], data[1], ..., data[digits-1]　にLEDパターンを入れる

LED_out(int digits,int LED_pattern[])
{
    int i, j;
    int d;

    for(j=digits-1; j>=0; j--) {
        d = LED_pattern[j];
        for(i=0; i<8; i++) {
            if (d & 0x80) digitalWrite(0,1);
                else digitalWrite(0,0);
             d = d << 1;
	     delayMicroseconds(c_wait);
             digitalWrite(1,1);         // SCLKをHに
	     delayMicroseconds(c_wait);
             digitalWrite(1,0);         // SCLKをLに
        }
    }
    delayMicroseconds(c_wait);
    digitalWrite(3,1);                  // RCLKをHに
    delayMicroseconds(c_wait);
    digitalWrite(3,0);                  // RCLKをLに
}

// n桁分の文字を整数で表示
// LED_dispint(int digits, int val)
// digits 桁数
// val 表示したい数

LED_dispint(int digits, int val)
{
    int i, buf;
    int LED_pattern[digits];
    char str[digits];

    sprintf(str,"%0*d",digits ,val);

    for(i=0; i<digits; i++)
        LED_pattern[i] = LED_Font[str[i] - '0'];

    LED_out(digits, LED_pattern);
}

main(int argc, char *argv[])
{
    int i;
    int digits;
    int max;

    // 桁数の受け取り
    if (argc != 2) {
        printf("usage : sudo ./a.out [digits]\n");
        exit(1);
    }
    digits = atoi(argv[1]);

    // ポートのセットアップ
    wiringPiSetup();
    pinMode(0, OUTPUT); // GPIO17 データ
    pinMode(1, OUTPUT); // GPIO18 シフトレジスタのクロック
    pinMode(3, OUTPUT); // GPIO22 D-FFのクロック
    digitalWrite(0,0);  // SERをLに
    digitalWrite(1,0);  // SCLKをLに
    digitalWrite(3,0);  // RCLKをLに

    // 与えられた桁数digitから、カウント上限を計算
    max = 1;
    for (i=0; i<digits; i++) max *= 10;

    // LEDへの表示
    while(1) {
	for(i=0; i<max; i++) {
            LED_dispint(digits,i);
            printf("%d\n",i);
            delay(10);
	}
    }
}

